// CompilerNode.cpp
//------------------------------------------------------------------------------

// Includes
//------------------------------------------------------------------------------
#include "CompilerNode.h"

#include <Tools/FBuild/FBuildCore/FBuild.h>
#include <Tools/FBuild/FBuildCore/Graph/NodeGraph.h>

//#include <Core/FileIO/FileIO.h>
#include <Core/FileIO/IOStream.h>
#include <Core/Strings/AStackString.h>

// CONSTRUCTOR
//------------------------------------------------------------------------------
CompilerNode::CompilerNode( const AString & exe )
	: FileNode( exe, ControlFlag::FLAG_NONE )
	, m_StaticDependencies( 1, false )
{
	m_Type = Node::COMPILER_NODE;
}

// DESTRUCTOR
//------------------------------------------------------------------------------
CompilerNode::~CompilerNode()
{
}

// DetermineNeedToBuild
//------------------------------------------------------------------------------
/*virtual*/ bool CompilerNode::DetermineNeedToBuild( bool forceClean )
{
	return FileNode::DetermineNeedToBuild( forceClean );
}

// DoBuild
//------------------------------------------------------------------------------
/*virtual*/ Node::BuildResult CompilerNode::DoBuild( Job * UNUSED( job ) )
{
	ASSERT( false ); // should never get here
	return NODE_RESULT_FAILED;
}

// GetDependencies
//------------------------------------------------------------------------------
/*virtual*/ const Array< Node * > & CompilerNode::GetStaticDependencies() const
{
	return m_StaticDependencies;
}

// Load
//------------------------------------------------------------------------------
/*static*/ Node * CompilerNode::Load( IOStream & stream, bool remote )
{
	NODE_LOAD( AStackString<>, exeName );

	NodeGraph & ng = FBuild::Get().GetDependencyGraph();
	Node * n = ng.CreateCompilerNode( exeName );
	ASSERT( n );
	return n;
}

// Save
//------------------------------------------------------------------------------
/*virtual*/ bool CompilerNode::Save( IOStream & stream ) const
{
	NODE_SAVE( m_Name );
	return true;
}

//------------------------------------------------------------------------------
